/[sysadmin-cookbook]/recepies/lxc/lxc-watchdog.sh
This is repository of my old source code which isn't updated any more. Go to git.rot13.org for current projects!
ViewVC logotype

Diff of /recepies/lxc/lxc-watchdog.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 189 by dpavlin, Tue Mar 16 23:05:31 2010 UTC revision 232 by dpavlin, Sun Oct 24 11:55:02 2010 UTC
# Line 16  Line 16 
16  #  #
17  # based on Tony Risinger post to lxc-users mailing list  # based on Tony Risinger post to lxc-users mailing list
18  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html  # http://www.mail-archive.com/lxc-users@lists.sourceforge.net/msg00074.html
19    #
20    # Install with:
21    # ln -sf /srv/sysadmin-cookbook/recepies/lxc/lxc-watchdog.sh /etc/init.d/lxc-watchdog
22    # update-rc.d lxc-watchdog defaults
23    
24    
25  which inotifywait >/dev/null || apt-get install inotify-tools  which inotifywait >/dev/null || apt-get install inotify-tools
# Line 33  lxc_exists() { Line 37  lxc_exists() {
37    
38    
39  lxc_rootfs() {  lxc_rootfs() {
40          grep lxc.rootfs "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'          grep '^ *lxc\.rootfs *=' "/var/lib/lxc/$1/config" | cut -d= -f2 | sed 's/^ *//'
41    }
42    
43    lxc_hostname() {
44            inside=`cat $(lxc_rootfs $1)/etc/hostname`
45            config=`grep lxc.utsname /var/lib/lxc/$name/config | cut -d= -f2`
46            echo "$config [$inside]";
47  }  }
48    
49    lxc_ip() {
50            grep lxc.network.ipv4 /var/lib/lxc/$name/config | cut -d= -f2 ||
51            grep address $(lxc_rootfs $name)/etc/network/interfaces | sed 's/.*address //'
52    }
53    
54  lxc_status() {  lxc_status() {
55          lxc-ls -1 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do          ( find /var/lib/lxc/ -name "config" | cut -d/ -f5 | sort -u | xargs -i lxc-info -n {} | sed "s/'//g" | while read name is status ; do
56                  boot="    "                  boot="-"
57                  test -s /var/lib/lxc/$name/on_boot && boot="boot"                  test -s /var/lib/lxc/$name/on_boot && boot="boot"
58                  echo "$name $status $boot $(lxc_rootfs $name)"                  echo "$name $status $boot $(lxc_rootfs $name) $(lxc_ip $name) $(lxc_hostname $name)"
59          done          done ) | column -t
60  }  }
61    
62    
# Line 53  cleanup_init_scripts() { Line 67  cleanup_init_scripts() {
67                  $rootfs/etc/rc?.d/*umountfs \                  $rootfs/etc/rc?.d/*umountfs \
68                  $rootfs/etc/rc?.d/*umountroot \                  $rootfs/etc/rc?.d/*umountroot \
69                  $rootfs/etc/rc?.d/*hwclock* \                  $rootfs/etc/rc?.d/*hwclock* \
70                    $rootfs/etc/rc?.d/*udev* \
71          2>/dev/null | xargs -i rm -v {}          2>/dev/null | xargs -i rm -v {}
72    
73            echo $1 > $rootfs/etc/hostname
74  }  }
75    
76    
# Line 64  setup_inittab() { Line 81  setup_inittab() {
81    
82          # let container respond to kill -SIGPWR          # let container respond to kill -SIGPWR
83          inittab=$rootfs/etc/inittab          inittab=$rootfs/etc/inittab
84          if ! grep "$add" ${inittab} >/dev/null ; then          if test -e $inittab && ! grep "$add" ${inittab} >/dev/null ; then
85                  grep -v "$remove" ${inittab} > ${inittab}.new                  grep -v "$remove" ${inittab} > ${inittab}.new
86                  echo $add >> ${inittab}.new                  echo $add >> ${inittab}.new
87                  mv ${inittab}.new ${inittab}                  mv ${inittab}.new ${inittab}
# Line 102  lxc_stop() { Line 119  lxc_stop() {
119    
120  lxc_start() {  lxc_start() {
121          name=$1          name=$1
122            rootfs=$(lxc_rootfs $1)
123    
124            if [ ! -e $rootfs ] ; then
125                    echo "ERROR $name rootfs $rootfs not found"
126                    return
127            fi
128    
129          if ! lxc-info -n $name | grep RUNNING ; then          if ! lxc-info -n $name | grep RUNNING ; then
130                  lxc_log "$name start"                  lxc_log "$name start"
# Line 160  lxc_log "$name watchdog exited" Line 183  lxc_log "$name watchdog exited"
183  }  }
184    
185    
186    usage() {
187            echo "Usage: $0 {start|stop|restart|status|boot|disable} [name name ... ]" >&2
188            exit 3
189    }
190    
191  command_on_lxc() {  command_on_lxc() {
192  command=$1  command=$1
193  shift  shift
# Line 171  case "$command" in Line 199  case "$command" in
199  start)  start)
200          lxc_exists $1          lxc_exists $1
201          cleanup_init_scripts $1          cleanup_init_scripts $1
202          setup_inittab $1 ::power      "p0::powerfail:/sbin/init 0"          setup_inittab $1 ":respawn:/sbin/getty.*tty1"   "c1:12345:respawn:/sbin/getty 38400 tty1 linux"
203          setup_inittab $1 ::ctrlaltdel "p6::ctrlaltdel:/sbin/init 6"          setup_inittab $1 "::power"                      "p0::powerfail:/sbin/init 0"
204            setup_inittab $1 "::ctrlaltdel"                 "p6::ctrlaltdel:/sbin/init 6"
205          lxc_start $1          lxc_start $1
206          # give container 5 seconds to start more than one process          # give container 5 seconds to start more than one process
207          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &          ( sleep 5 ; nohup $0 watchdog $1 >> /tmp/$1.log 2>/dev/null ) &
# Line 194  disable) Line 223  disable)
223          echo -n > /var/lib/lxc/$1/on_boot          echo -n > /var/lib/lxc/$1/on_boot
224          ;;          ;;
225  *)  *)
226          echo "Usage: $0 {start|stop|restart|status}" >&2          usage
         exit 3  
227          ;;          ;;
228    
229  esac  esac
# Line 203  esac Line 231  esac
231  }  }
232    
233  command=$1  command=$1
234  shift  test -z "$command" && usage
   
235  test "$command" = "status" && lxc_status && exit  test "$command" = "status" && lxc_status && exit
236    shift
237    
238  if [ -z "$1" ] ; then  if [ -z "$1" ] ; then
239          ls /var/lib/lxc/*/on_boot | while read path ; do          ls /var/lib/lxc/*/on_boot | while read path ; do

Legend:
Removed from v.189  
changed lines
  Added in v.232

  ViewVC Help
Powered by ViewVC 1.1.26